module BaudGenerator( clock_in,
						baud_clock_out);


input wire clock_in;
output wire baud_clock_out;

//Code Referenced from www.fpga4fun.com/SerialInterface2.html
parameter ClkFrequency = 50000000; // MHz
parameter Baud = 115200;
parameter BaudGeneratorAccWidth = 16;
//parameter BaudGeneratorInc = (Baud << BaudGeneratorAccWidth) / ClkFrequency;
parameter BaudGeneratorInc = ((Baud << (BaudGeneratorAccWidth - 4)) + (ClkFrequency>>5))/(ClkFrequency>>4);

reg [BaudGeneratorAccWidth:0] BaudGeneratorAcc;
always @(posedge clock_in) begin
	BaudGeneratorAcc <= BaudGeneratorAcc[BaudGeneratorAccWidth-1:0] + BaudGeneratorInc;
end

wire BaudTick = BaudGeneratorAcc[BaudGeneratorAccWidth];

assign baud_clock_out = BaudTick;
						
endmodule
