module BaudGenerator_fast( clock_in,
						baud_clock_out);


input wire clock_in;
output wire baud_clock_out;

//Code Referenced from www.fpga4fun.com/SerialInterface2.html
parameter ClkFrequency = 50000000; // MHz
parameter Baud = 921600;
parameter BaudGeneratorAccWidth = 16;
//parameter BaudGeneratorInc = (Baud << BaudGeneratorAccWidth) / ClkFrequency;
parameter BaudGeneratorInc = ((Baud<<(BaudGeneratorAccWidth-7))+(ClkFrequency>>8))/(ClkFrequency>>7);


reg [BaudGeneratorAccWidth:0] BaudGeneratorAcc;
always @(posedge clock_in) begin
	BaudGeneratorAcc <= BaudGeneratorAcc[BaudGeneratorAccWidth-1:0] + BaudGeneratorInc;
end

wire BaudTick = BaudGeneratorAcc[BaudGeneratorAccWidth];

assign baud_clock_out = BaudTick;
						
endmodule
