module Color_MUX(
					cCF, cCD, cSD, cSF, cLD, cTW, cIDLE,
					clock, select, 
					cOut


);

input wire [15:0] cCF, cCD, cSD, cSF, cLD, cTW, cIDLE;
input wire clock;
input wire [3:0] select;
output wire [15:0] cOut;
reg [15:0] cReg;
assign cOut = cReg;

parameter 	[3:0] 	circle_fill = 4'd0,
					circle_draw = 4'd1,
					square_fill = 4'd2,
					square_draw = 4'd3,
					line_draw = 4'd4,
					text_write = 4'd5,
					frame_update = 4'd6,
					idle = 4'd15;


always @(posedge clock) begin
	case(select)
		circle_fill: begin cReg <= cCF; end
		circle_draw: begin cReg <= cCD; end
		square_fill: begin cReg <= cSF; end
		square_draw: begin cReg <= cSD; end
		line_draw: begin cReg <= cLD; end
		text_write: begin cReg <= cTW; end
		idle: begin cReg <= cIDLE; end
		default: begin
			cReg <= 16'hF000;
		end
	endcase
end

endmodule

