
module CommandManager(CLK, reset, packet_available, module_available, ready_for_next);

input CLK;
input reset;

input packet_available;
input module_available;

output ready_for_next;
reg ready_for_next_reg;

assign ready_for_next = ready_for_next_reg;

reg [2:0] state;

parameter wait_new_packet = 3'd0,
			wait_module_done = 3'd1,
			safety = 3'd2;

/*
always @ (posedge CLK) begin
	if(reset) begin
		state <= wait_new_packet;
		ready_for_next_reg <= 1'b0;
	end
	else begin
	
		case(state)
			wait_new_packet: begin
				if(packet_available) begin
					state <= safety;
				end
				ready_for_next_reg <= 1'b0;
			end
			
			safety: begin
				state <= wait_module_done;
			end
			
			wait_module_done: begin
				if(module_available) begin
					ready_for_next_reg <= 1'b1;
					state <= packet_available;
				end
			end
			
			default: begin
				state <= wait_new_packet;
				ready_for_next_reg <= 1'b0;
			end
						
		endcase
		
	end
end
	*/
	reg last_ma;
	always @ (posedge CLK) begin
		if(reset) begin
			ready_for_next_reg <= 1'b0;
		end
		else begin
			if(last_ma != module_available && module_available == 1'b1) begin
				ready_for_next_reg <= 1'b1;
			end
			else begin
				ready_for_next_reg <= 1'b0;
			end
		end
		last_ma <= module_available;
	end




endmodule

