
module DE2_Default_james
	(
		////////////////////	Clock Input	 	////////////////////	 
		CLOCK_27,						//	27 MHz
		CLOCK_50,						//	50 MHz
		EXT_CLOCK,						//	External Clock
		////////////////////	Push Button		////////////////////
		KEY,							//	Pushbutton[3:0]
		////////////////////	DPDT Switch		////////////////////
		SW,								//	Toggle Switch[17:0]
		////////////////////	7-SEG Dispaly	////////////////////
		HEX0,							//	Seven Segment Digit 0
		HEX1,							//	Seven Segment Digit 1
		HEX2,							//	Seven Segment Digit 2
		HEX3,							//	Seven Segment Digit 3
		HEX4,							//	Seven Segment Digit 4
		HEX5,							//	Seven Segment Digit 5
		HEX6,							//	Seven Segment Digit 6
		HEX7,							//	Seven Segment Digit 7
		////////////////////////	LED		////////////////////////
		LEDG,							//	LED Green[8:0]
		LEDR,							//	LED Red[17:0]
		////////////////////////	UART	////////////////////////
		UART_TXD,						//	UART Transmitter
		UART_RXD,						//	UART Receiver
		////////////////////////	IRDA	////////////////////////
		IRDA_TXD,						//	IRDA Transmitter
		IRDA_RXD,						//	IRDA Receiver
		/////////////////////	SDRAM Interface		////////////////
		DRAM_DQ,						//	SDRAM Data bus 16 Bits
		DRAM_ADDR,						//	SDRAM Address bus 12 Bits
		DRAM_LDQM,						//	SDRAM Low-byte Data Mask 
		DRAM_UDQM,						//	SDRAM High-byte Data Mask
		DRAM_WE_N,						//	SDRAM Write Enable
		DRAM_CAS_N,						//	SDRAM Column Address Strobe
		DRAM_RAS_N,						//	SDRAM Row Address Strobe
		DRAM_CS_N,						//	SDRAM Chip Select
		DRAM_BA_0,						//	SDRAM Bank Address 0
		DRAM_BA_1,						//	SDRAM Bank Address 0
		DRAM_CLK,						//	SDRAM Clock
		DRAM_CKE,						//	SDRAM Clock Enable
		////////////////////	Flash Interface		////////////////
		FL_DQ,							//	FLASH Data bus 8 Bits
		FL_ADDR,						//	FLASH Address bus 22 Bits
		FL_WE_N,						//	FLASH Write Enable
		FL_RST_N,						//	FLASH Reset
		FL_OE_N,						//	FLASH Output Enable
		FL_CE_N,						//	FLASH Chip Enable
		////////////////////	SRAM Interface		////////////////
		SRAM_DQ,						//	SRAM Data bus 16 Bits
		SRAM_ADDR,						//	SRAM Address bus 18 Bits
		SRAM_UB_N,						//	SRAM High-byte Data Mask 
		SRAM_LB_N,						//	SRAM Low-byte Data Mask 
		SRAM_WE_N,						//	SRAM Write Enable
		SRAM_CE_N,						//	SRAM Chip Enable
		SRAM_OE_N,						//	SRAM Output Enable
		////////////////////	ISP1362 Interface	////////////////
		OTG_DATA,						//	ISP1362 Data bus 16 Bits
		OTG_ADDR,						//	ISP1362 Address 2 Bits
		OTG_CS_N,						//	ISP1362 Chip Select
		OTG_RD_N,						//	ISP1362 Write
		OTG_WR_N,						//	ISP1362 Read
		OTG_RST_N,						//	ISP1362 Reset
		OTG_FSPEED,						//	USB Full Speed,	0 = Enable, Z = Disable
		OTG_LSPEED,						//	USB Low Speed, 	0 = Enable, Z = Disable
		OTG_INT0,						//	ISP1362 Interrupt 0
		OTG_INT1,						//	ISP1362 Interrupt 1
		OTG_DREQ0,						//	ISP1362 DMA Request 0
		OTG_DREQ1,						//	ISP1362 DMA Request 1
		OTG_DACK0_N,					//	ISP1362 DMA Acknowledge 0
		OTG_DACK1_N,					//	ISP1362 DMA Acknowledge 1
		////////////////////	LCD Module 16X2		////////////////
		LCD_ON,							//	LCD Power ON/OFF
		LCD_BLON,						//	LCD Back Light ON/OFF
		LCD_RW,							//	LCD Read/Write Select, 0 = Write, 1 = Read
		LCD_EN,							//	LCD Enable
		LCD_RS,							//	LCD Command/Data Select, 0 = Command, 1 = Data
		LCD_DATA,						//	LCD Data bus 8 bits
		////////////////////	SD_Card Interface	////////////////
		SD_DAT,							//	SD Card Data
		SD_DAT3,						//	SD Card Data 3
		SD_CMD,							//	SD Card Command Signal
		SD_CLK,							//	SD Card Clock
		////////////////////	USB JTAG link	////////////////////
		TDI,  							// CPLD -> FPGA (data in)
		TCK,  							// CPLD -> FPGA (clk)
		TCS,  							// CPLD -> FPGA (CS)
	    TDO,  							// FPGA -> CPLD (data out)
		////////////////////	I2C		////////////////////////////
		I2C_SDAT,						//	I2C Data
		I2C_SCLK,						//	I2C Clock
		////////////////////	PS2		////////////////////////////
		PS2_DAT,						//	PS2 Data
		PS2_CLK,						//	PS2 Clock
		////////////////////	VGA		////////////////////////////
		VGA_CLK,   						//	VGA Clock
		VGA_HS,							//	VGA H_SYNC
		VGA_VS,							//	VGA V_SYNC
		VGA_BLANK,						//	VGA BLANK
		VGA_SYNC,						//	VGA SYNC
		VGA_R,   						//	VGA Red[9:0]
		VGA_G,	 						//	VGA Green[9:0]
		VGA_B,  						//	VGA Blue[9:0]
		////////////	Ethernet Interface	////////////////////////
		ENET_DATA,						//	DM9000A DATA bus 16Bits
		ENET_CMD,						//	DM9000A Command/Data Select, 0 = Command, 1 = Data
		ENET_CS_N,						//	DM9000A Chip Select
		ENET_WR_N,						//	DM9000A Write
		ENET_RD_N,						//	DM9000A Read
		ENET_RST_N,						//	DM9000A Reset
		ENET_INT,						//	DM9000A Interrupt
		ENET_CLK,						//	DM9000A Clock 25 MHz
		////////////////	Audio CODEC		////////////////////////
		AUD_ADCLRCK,					//	Audio CODEC ADC LR Clock
		AUD_ADCDAT,						//	Audio CODEC ADC Data
		AUD_DACLRCK,					//	Audio CODEC DAC LR Clock
		AUD_DACDAT,						//	Audio CODEC DAC Data
		AUD_BCLK,						//	Audio CODEC Bit-Stream Clock
		AUD_XCK,						//	Audio CODEC Chip Clock
		////////////////	TV Decoder		////////////////////////
		TD_DATA,    					//	TV Decoder Data bus 8 bits
		TD_HS,							//	TV Decoder H_SYNC
		TD_VS,							//	TV Decoder V_SYNC
		TD_RESET,						//	TV Decoder Reset
		////////////////////	GPIO	////////////////////////////
		GPIO_0,							//	GPIO Connection 0
		GPIO_1							//	GPIO Connection 1
	);

////////////////////////	Clock Input	 	////////////////////////
input			CLOCK_27;				//	27 MHz
input			CLOCK_50;				//	50 MHz
input			EXT_CLOCK;				//	External Clock
////////////////////////	Push Button		////////////////////////
input	[3:0]	KEY;					//	Pushbutton[3:0]
////////////////////////	DPDT Switch		////////////////////////
input	[17:0]	SW;						//	Toggle Switch[17:0]
////////////////////////	7-SEG Dispaly	////////////////////////
output	[6:0]	HEX0;					//	Seven Segment Digit 0
output	[6:0]	HEX1;					//	Seven Segment Digit 1
output	[6:0]	HEX2;					//	Seven Segment Digit 2
output	[6:0]	HEX3;					//	Seven Segment Digit 3
output	[6:0]	HEX4;					//	Seven Segment Digit 4
output	[6:0]	HEX5;					//	Seven Segment Digit 5
output	[6:0]	HEX6;					//	Seven Segment Digit 6
output	[6:0]	HEX7;					//	Seven Segment Digit 7
////////////////////////////	LED		////////////////////////////
output	[8:0]	LEDG;					//	LED Green[8:0]
output	[17:0]	LEDR;					//	LED Red[17:0]
////////////////////////////	UART	////////////////////////////
output			UART_TXD;				//	UART Transmitter
input			UART_RXD;				//	UART Receiver
////////////////////////////	IRDA	////////////////////////////
output			IRDA_TXD;				//	IRDA Transmitter
input			IRDA_RXD;				//	IRDA Receiver
///////////////////////		SDRAM Interface	////////////////////////
inout	[15:0]	DRAM_DQ;				//	SDRAM Data bus 16 Bits
output	[11:0]	DRAM_ADDR;				//	SDRAM Address bus 12 Bits
output			DRAM_LDQM;				//	SDRAM Low-byte Data Mask 
output			DRAM_UDQM;				//	SDRAM High-byte Data Mask
output			DRAM_WE_N;				//	SDRAM Write Enable
output			DRAM_CAS_N;				//	SDRAM Column Address Strobe
output			DRAM_RAS_N;				//	SDRAM Row Address Strobe
output			DRAM_CS_N;				//	SDRAM Chip Select
output			DRAM_BA_0;				//	SDRAM Bank Address 0
output			DRAM_BA_1;				//	SDRAM Bank Address 0
output			DRAM_CLK;				//	SDRAM Clock
output			DRAM_CKE;				//	SDRAM Clock Enable
////////////////////////	Flash Interface	////////////////////////
inout	[7:0]	FL_DQ;					//	FLASH Data bus 8 Bits
output	[21:0]	FL_ADDR;				//	FLASH Address bus 22 Bits
output			FL_WE_N;				//	FLASH Write Enable
output			FL_RST_N;				//	FLASH Reset
output			FL_OE_N;				//	FLASH Output Enable
output			FL_CE_N;				//	FLASH Chip Enable
////////////////////////	SRAM Interface	////////////////////////
inout	[15:0]	SRAM_DQ;				//	SRAM Data bus 16 Bits
output	[17:0]	SRAM_ADDR;				//	SRAM Address bus 18 Bits
output			SRAM_UB_N;				//	SRAM High-byte Data Mask
output			SRAM_LB_N;				//	SRAM Low-byte Data Mask 
output			SRAM_WE_N;				//	SRAM Write Enable
output			SRAM_CE_N;				//	SRAM Chip Enable
output			SRAM_OE_N;				//	SRAM Output Enable
////////////////////	ISP1362 Interface	////////////////////////
inout	[15:0]	OTG_DATA;				//	ISP1362 Data bus 16 Bits
output	[1:0]	OTG_ADDR;				//	ISP1362 Address 2 Bits
output			OTG_CS_N;				//	ISP1362 Chip Select
output			OTG_RD_N;				//	ISP1362 Write
output			OTG_WR_N;				//	ISP1362 Read
output			OTG_RST_N;				//	ISP1362 Reset
output			OTG_FSPEED;				//	USB Full Speed,	0 = Enable, Z = Disable
output			OTG_LSPEED;				//	USB Low Speed, 	0 = Enable, Z = Disable
input			OTG_INT0;				//	ISP1362 Interrupt 0
input			OTG_INT1;				//	ISP1362 Interrupt 1
input			OTG_DREQ0;				//	ISP1362 DMA Request 0
input			OTG_DREQ1;				//	ISP1362 DMA Request 1
output			OTG_DACK0_N;			//	ISP1362 DMA Acknowledge 0
output			OTG_DACK1_N;			//	ISP1362 DMA Acknowledge 1
////////////////////	LCD Module 16X2	////////////////////////////
inout	[7:0]	LCD_DATA;				//	LCD Data bus 8 bits
output			LCD_ON;					//	LCD Power ON/OFF
output			LCD_BLON;				//	LCD Back Light ON/OFF
output			LCD_RW;					//	LCD Read/Write Select, 0 = Write, 1 = Read
output			LCD_EN;					//	LCD Enable
output			LCD_RS;					//	LCD Command/Data Select, 0 = Command, 1 = Data
////////////////////	SD Card Interface	////////////////////////
inout			SD_DAT;					//	SD Card Data
inout			SD_DAT3;				//	SD Card Data 3
inout			SD_CMD;					//	SD Card Command Signal
output			SD_CLK;					//	SD Card Clock
////////////////////////	I2C		////////////////////////////////
inout			I2C_SDAT;				//	I2C Data
output			I2C_SCLK;				//	I2C Clock
////////////////////////	PS2		////////////////////////////////
input		 	PS2_DAT;				//	PS2 Data
input			PS2_CLK;				//	PS2 Clock
////////////////////	USB JTAG link	////////////////////////////
input  			TDI;					// CPLD -> FPGA (data in)
input  			TCK;					// CPLD -> FPGA (clk)
input  			TCS;					// CPLD -> FPGA (CS)
output 			TDO;					// FPGA -> CPLD (data out)
////////////////////////	VGA			////////////////////////////
output			VGA_CLK;   				//	VGA Clock
output			VGA_HS;					//	VGA H_SYNC
output			VGA_VS;					//	VGA V_SYNC
output			VGA_BLANK;				//	VGA BLANK
output			VGA_SYNC;				//	VGA SYNC
output	[9:0]	VGA_R;   				//	VGA Red[9:0]
output	[9:0]	VGA_G;	 				//	VGA Green[9:0]
output	[9:0]	VGA_B;   				//	VGA Blue[9:0]
////////////////	Ethernet Interface	////////////////////////////
inout	[15:0]	ENET_DATA;				//	DM9000A DATA bus 16Bits
output			ENET_CMD;				//	DM9000A Command/Data Select, 0 = Command, 1 = Data
output			ENET_CS_N;				//	DM9000A Chip Select
output			ENET_WR_N;				//	DM9000A Write
output			ENET_RD_N;				//	DM9000A Read
output			ENET_RST_N;				//	DM9000A Reset
input			ENET_INT;				//	DM9000A Interrupt
output			ENET_CLK;				//	DM9000A Clock 25 MHz
////////////////////	Audio CODEC		////////////////////////////
output/*inout*/	AUD_ADCLRCK;			//	Audio CODEC ADC LR Clock
input			AUD_ADCDAT;				//	Audio CODEC ADC Data
inout			AUD_DACLRCK;			//	Audio CODEC DAC LR Clock
output			AUD_DACDAT;				//	Audio CODEC DAC Data
inout			AUD_BCLK;				//	Audio CODEC Bit-Stream Clock
output			AUD_XCK;				//	Audio CODEC Chip Clock
////////////////////	TV Devoder		////////////////////////////
input	[7:0]	TD_DATA;    			//	TV Decoder Data bus 8 bits
input			TD_HS;					//	TV Decoder H_SYNC
input			TD_VS;					//	TV Decoder V_SYNC
output			TD_RESET;				//	TV Decoder Reset
////////////////////////	GPIO	////////////////////////////////
inout	[35:0]	GPIO_0;					//	GPIO Connection 0
inout	[35:0]	GPIO_1;					//	GPIO Connection 1

//////////////////////////////////////////////////////////////////////
////////////////////////////////////
//DLA state machine variables
wire reset;
wire we; // we for SRAM
wire [17:0] addr_reg; //memory address register for SRAM
wire [15:0] data_reg; //memory data register  for SRAM
assign reset = ~KEY[0];
////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

//	LCD ON
assign	LCD_ON		=	1'b0;
assign	LCD_BLON	=	1'b0;

//	All inout port turn to tri-state
assign	DRAM_DQ		=	16'hzzzz;
assign	FL_DQ		=	8'hzz;
assign	SRAM_DQ		=	16'hzzzz;
assign	OTG_DATA	=	16'hzzzz;
assign	SD_DAT		=	1'bz;
assign	ENET_DATA	=	16'hzzzz;
assign	GPIO_0		=	36'hzzzzzzzzz;
assign	GPIO_1		=	36'hzzzzzzzzz;

wire		VGA_CTRL_CLK;
wire		AUD_CTRL_CLK;
wire [9:0]	mVGA_R, mVGA_R1, mVGA_R2, mVGA_R3, mVGA_R4;
wire [9:0]	mVGA_G, mVGA_G1, mVGA_G2, mVGA_G3, mVGA_G4;
wire [9:0]	mVGA_B, mVGA_B1, mVGA_B2, mVGA_B3, mVGA_B4;
wire [19:0]	mVGA_ADDR;			//video memory address
wire [9:0]  Coord_X, Coord_Y;	//display coods
wire		DLY_RST;

assign	TD_RESET	=	1'b1;	//	Allow 27 MHz input

Reset_Delay			r0	(	.iCLK(CLOCK_50),.oRESET(DLY_RST)	);

VGA_Audio_PLL 		p1	(	.areset(~DLY_RST),.inclk0(CLOCK_27),.c0(VGA_CTRL_CLK),.c1(AUD_CTRL_CLK),.c2(VGA_CLK)	);


VGA_Controller		u1	(	//	Host Side
							.iCursor_RGB_EN(4'b0111),
							.oAddress(mVGA_ADDR),
							.oCoord_X(Coord_X),
							.oCoord_Y(Coord_Y),
							.iRed(mVGA_R),
							.iGreen(mVGA_G),
							.iBlue(mVGA_B),
							//	VGA Side
							.oVGA_R(VGA_R),
							.oVGA_G(VGA_G),
							.oVGA_B(VGA_B),
							.oVGA_H_SYNC(VGA_HS),
							.oVGA_V_SYNC(VGA_VS),
							.oVGA_SYNC(VGA_SYNC),
							.oVGA_BLANK(VGA_BLANK),
							//	Control Signal
							.iCLK(VGA_CTRL_CLK),
							.iRST_N(DLY_RST)	);

// SRAM_control
assign SRAM_ADDR = addr_reg;
assign SRAM_DQ = (we)? 16'hzzzz : data_reg ;
assign SRAM_UB_N = 0;					// hi byte select enabled
assign SRAM_LB_N = 0;					// lo byte select enabled
assign SRAM_CE_N = 0;					// chip is enabled
assign SRAM_WE_N = we;					// write when ZERO
assign SRAM_OE_N = 0;					//output enable is overidden by WE

parameter [2:0]	sixteenBit_single_320x240 = 3'd0,
				eightBit_single_640x480 = 3'd1,
				eightBit_double_320x240 = 3'd2,
				fourBit_double_640x480 = 3'd3,
				fiveBit_triple_320x240 = 3'd4,
				fourBit_quad_320x240 = 3'd5,
				twoBit_quad_640x480 = 3'd6,
				foreground_background = 3'd7;

// Show SRAM on the VGA
//320x240 single frame
assign  mVGA_R1 = {SRAM_DQ[15:12], 6'b0} ;
assign  mVGA_G1 = {SRAM_DQ[11:8], 6'b0} ;
assign  mVGA_B1 = {SRAM_DQ[7:4], 6'b0} ;
//640x480 - single frame
assign  mVGA_R2 = (Coord_X[0]) ? {SRAM_DQ[15:13], SRAM_DQ[15:13],SRAM_DQ[15:13],1'b1} : {SRAM_DQ[7:5], SRAM_DQ[7:5],SRAM_DQ[7:5],1'b1} ;
assign  mVGA_G2 = (Coord_X[0]) ? {SRAM_DQ[12:10], SRAM_DQ[12:10],SRAM_DQ[12:10],1'b1} : {SRAM_DQ[4:2], SRAM_DQ[4:2],SRAM_DQ[4:2],1'b1};
assign  mVGA_B2 = (Coord_X[0]) ? {SRAM_DQ[9:8], SRAM_DQ[9:8],SRAM_DQ[9:8],SRAM_DQ[9:8],SRAM_DQ[9:8]}  : {SRAM_DQ[1:0], SRAM_DQ[1:0],SRAM_DQ[1:0],SRAM_DQ[1:0],SRAM_DQ[1:0]};
//320x240 - double frame
assign  mVGA_R3 = ~readFrame ? {SRAM_DQ[15:13], SRAM_DQ[15:13],SRAM_DQ[15:13],1'b1} : {SRAM_DQ[7:5], SRAM_DQ[7:5],SRAM_DQ[7:5],1'b1} ;
assign  mVGA_G3 = ~readFrame ? {SRAM_DQ[12:10], SRAM_DQ[12:10],SRAM_DQ[12:10],1'b1} : {SRAM_DQ[4:2], SRAM_DQ[4:2],SRAM_DQ[4:2],1'b1};
assign  mVGA_B3 = ~readFrame ? {SRAM_DQ[9:8], SRAM_DQ[9:8],SRAM_DQ[9:8],SRAM_DQ[9:8],SRAM_DQ[9:8]}  : {SRAM_DQ[1:0], SRAM_DQ[1:0],SRAM_DQ[1:0],SRAM_DQ[1:0],SRAM_DQ[1:0]};
//640x480 - double frame
assign mVGA_R4 = ~Coord_X[0] ? (readFrame ? ({10{SRAM_DQ[7]}}) : ({10{SRAM_DQ[3]}})) : (readFrame ? ({10{SRAM_DQ[11]}}) : ({10{SRAM_DQ[15]}}));
assign mVGA_G4 = ~Coord_X[0] ? (readFrame ? ({5{SRAM_DQ[6:5]}}) : ({5{SRAM_DQ[2:1]}})) : (readFrame ? ({5{SRAM_DQ[10:9]}}) : ({5{SRAM_DQ[14:13]}}));
assign mVGA_B4 = ~Coord_X[0] ? (readFrame ? ({10{SRAM_DQ[4]}}) : ({10{SRAM_DQ[0]}})) : (readFrame ? ({10{SRAM_DQ[8]}}) : ({10{SRAM_DQ[12]}}));

assign mVGA_R = (drawMode == sixteenBit_single_320x240) ? mVGA_R1:
				(drawMode == eightBit_single_640x480) 	? mVGA_R2:
				(drawMode == eightBit_double_320x240) 	? mVGA_R3:
				(drawMode == fourBit_double_640x480) 	? mVGA_R4: 10'd0;
				

assign mVGA_G = (drawMode == sixteenBit_single_320x240) ? mVGA_G1:
				(drawMode == eightBit_single_640x480) 	? mVGA_G2:
				(drawMode == eightBit_double_320x240) 	? mVGA_G3:
				(drawMode == fourBit_double_640x480) 	? mVGA_G4: 10'd0;
				

assign mVGA_B = (drawMode == sixteenBit_single_320x240) ? mVGA_B1:
				(drawMode == eightBit_single_640x480) 	? mVGA_B2:
				(drawMode == eightBit_double_320x240) 	? mVGA_B3:
				(drawMode == fourBit_double_640x480) 	? mVGA_B4: 10'd0;


wire LD_available, CD_available, CF_available, SD_available, SF_available, TW_available, FU_available;

parameter 	[3:0] 	circle_fill = 4'd0,
					circle_draw = 4'd1,
					square_fill = 4'd2,
					square_draw = 4'd3,
					line_draw = 4'd4,
					text_write = 4'd5,
					frame_update = 4'd6;

line_drawer LD1(
			.x1(xstart_req),
			.y1(ystart_req),
			.x2(xend_width_req),
			.y2(yend_height_req),
			.VGA_SYNC(~VGA_VS | ~VGA_HS),
			.VGA_CLK(VGA_CTRL_CLK),
			.data_reg(cLD),
			.reset(reset),
			.color({color_req,4'h0}),
			.command({cmd_req,1'b0}),
			.available(LD_available),
			.my_id(line_draw),
			.id_req(avail_select),
			.xAddr(xLD),
			.yAddr(yLD),
			.is_write_finished(isWriteFinished),
			.write_clk(wLD)
			);
			

circle_draw CD1(
			.x1(xstart_req),
			.y1({1'b0,ystart_req}),
			.radius(xend_width_req),
			.VGA_SYNC(~VGA_VS | ~VGA_HS),
			.VGA_CLK(VGA_CTRL_CLK),
			.data_reg(cCD),
			.reset(reset),
			.color({color_req,4'h0}),
			.command({cmd_req,1'b0}),
			.available(CD_available),
			.my_id(circle_draw),
			.id_req(avail_select),
			.xAddr(xCD),
			.yAddr(yCD),
			.is_write_finished(isWriteFinished),
			.write_clk(wCD)
			);

		
			
square_draw SD1(
			.x1(xstart_req),
			.y1(ystart_req),
			.width(xend_width_req),
			.height(yend_height_req),
			.VGA_SYNC(~VGA_VS | ~VGA_HS),
			.VGA_CLK(VGA_CTRL_CLK),
			.data_reg(cSD),
			.reset(reset),
			.color({color_req,4'h0}),
			.command({cmd_req,1'b0}),
			.available(SD_available),
			.my_id(square_draw),
			.id_req(avail_select),
			.xAddr(xSD),
			.yAddr(ySD),
			.is_write_finished(isWriteFinished),
			.write_clk(wSD)
			);
			
square_fill SF1(
			.x1(xstart_req),
			.y1(ystart_req),
			.width(xend_width_req),
			.height(yend_height_req),
			.VGA_SYNC(~VGA_VS | ~VGA_HS),
			.VGA_CLK(VGA_CTRL_CLK),
			.data_reg(cSF),
			.reset(reset),
			.color({color_req,4'h0}),
			.command({cmd_req,1'b0}),
			.available(SF_available),
			.my_id(square_fill),
			.id_req(avail_select),
			.xAddr(xSF),
			.yAddr(ySF),
			.is_write_finished(isWriteFinished),
			.write_clk(wSF)
			);
			
			
circle_fill_better CFB1(
			.x1(xstart_req),
			.y1({1'b0,ystart_req}),
			.radius(xend_width_req),
			.VGA_SYNC(~VGA_VS | ~VGA_HS),
			.VGA_CLK(VGA_CTRL_CLK),
			.reset(reset),
			.color({color_req,4'h0}),
			.command({cmd_req,1'b0}),
			.data_reg(cCF),
			.available(CF_available),
			.my_id(circle_fill),
			.id_req(avail_select),
			.xAddr(xCF),
			.yAddr(yCF),
			.is_write_finished(isWriteFinished),
			.write_clk(wCF)
			);
			
TextWriter tw1(
				.VGA_SYNC(~VGA_VS | ~VGA_HS), 
				.VGA_CLK(VGA_CTRL_CLK),
				.data_reg(cTW),
				.reset(reset),
				.my_id(text_write), 
				.id_req(avail_select),
				.command({cmd_req,1'b0}),
				.color({color_req,4'h0}),
				.font_select(2'b0),
				.letter_addr({xend_width_req,yend_height_req[8:7]}), 
				.letterX(xstart_req), 
				.letterY(ystart_req),
				.available(TW_available),
				.xAddr(xTW),
				.yAddr(yTW),
				.is_write_finished(isWriteFinished),
				.write_clk(wTW)
				);




DataWriter dw1(
					.x_addr(xAddr), //x coordinate of pixel to draw to
					.y_addr(yAddr), //y coordinate of pixel to draw to
					.color_data(cValue), //the color data
					.isFinished(isWriteFinished), //flag if the write has completed
					.clock(VGA_CTRL_CLK), //the clock to handle the writing
					.sync(~VGA_VS | ~VGA_HS), //to keep us in sync with VGA
					.reset(~KEY[0]), // a reset signal
					.write_req_clk(write_clock), //clock that starts a new write request
					.read_addr_out(addr_reg), //the address we want to read data from
					.data_write_out(data_reg), //the new data that we will write to SRAM
					.we_out(we), //the write enable signal (0 = write, 1 = read)
					.read_data_in(SRAM_DQ), //the data that was read
					//.currFrame_out(LEDR[17:16]),
					.drawMode_sel(drawMode),
					.frame_sel(writeFrame),
					.Coord_X(Coord_X),
					.Coord_Y(Coord_Y)

);
wire [2:0] drawMode;

assign drawMode = extra1_req[7:5];
//assign frame_sel = extra1_req[4:3];

wire [9:0] xCF, xCD, xSD, xSF, xLD, xTW, xIDLE, xAddr;
wire [8:0] yCF, yCD, ySD, ySF, yLD, yTW, yIDLE, yAddr;
wire [15:0] cCF, cCD, cSD, cSF, cLD, cTW, cIDLE, cValue;
wire isWriteFinished;
wire write_clock;
wire wCF, wCD, wSD, wSF, wLD, wTW, wIDLE;

assign write_clock = wCF | wCD | wSD | wSF | wLD | wTW;

XAddr_MUX xam1(
					.xCF(xCF),
					.xCD(xCD),
					.xSD(xSD),
					.xSF(xSF),
					.xLD(xLD),
					.xTW(xTW),
					.xIDLE(xIDLE),
					.clock(VGA_CTRL_CLK),
					.select(avail_select), 
					.xOut(xAddr)
);

YAddr_MUX yam1(
					.yCF(yCF),
					.yCD(yCD),
					.ySD(ySD),
					.ySF(ySF),
					.yLD(yLD),
					.yTW(yTW),
					.yIDLE(yIDLE),
					.clock(VGA_CTRL_CLK),
					.select(avail_select), 
					.yOut(yAddr)
);

Color_MUX cm1(
					.cCF(cCF),
					.cCD(cCD),
					.cSD(cSD),
					.cSF(cSF),
					.cLD(cLD),
					.cTW(cTW),
					.cIDLE(cIDLE),
					.clock(VGA_CTRL_CLK),
					.select(avail_select), 
					.cOut(cValue)
);


wire avail_result;
wire [3:0] avail_select;
				
availableMUX AM1( 	.clk(VGA_CTRL_CLK),
						.availability_out(avail_result),
						.CD_available(CD_available),
						.CF_available(CF_available),
						.SF_available(SF_available),
						.SD_available(SD_available),
						.LD_available(LD_available),
						.TW_available(TW_available),
						.FU_available(FU_available),
						.select(avail_select),
						.enable(1'b1)
					);

//assign LEDR[15:9] = {CD_available, CF_available, SF_available, SD_available, LD_available, TW_available, FU_available};
//assign LEDR[3:0] = avail_select;
wire [11:0] color_req;
wire [9:0] xstart_req, xend_width_req;
wire [8:0] ystart_req, yend_height_req;
wire [7:0] extra1_req, extra2_req;
wire [5:0] instr_req;
wire cmd_req;




wire grabPacketClock;
wire sendDataClock;
wire readFrame;
wire writeFrame;
RequestManager_update rmu1(
//RequestHandler rh1(
							.clock(VGA_CTRL_CLK),
							.packet_in(currentPacket),//currentPacket),
							.packet_crc_in(currentPacketCRC),
							.packet_available(pavail),
							.ocolor(color_req),
							.oxstart(xstart_req),
							.oystart(ystart_req),
							.oxend_width(xend_width_req),
							.oyend_height(yend_height_req),
							.oextra1(extra1_req),
							.oextra2(extra2_req),
							.oinstr(instr_req),
							.reset(~KEY[0]),
							.grab_out(grabPacketClock),
							.nodeWanted(avail_select),
							.nodeWanted_isAvailable(avail_result),
							.command_out(cmd_req),
							.sync(~VGA_VS | ~VGA_HS),
							.transmit_clock(sendDataClock),
							.isTransmitting(currentlySendingData),
							.my_state(LEDG[7:4]),
							.packetID(packetID),
							.frame_read(readFrame),
							.frame_write(writeFrame),
							//.SW(SW),
							//.IRAM_out(IRAM_out),
							//.drawMode(drawMode)//,
							//.bug_check(LEDR[7:0])
							);	

wire took_packet;
wire packet_avail;
wire [79:0] IRAM_out;

assign LEDR[17:0] = SW[2:0] == 3'd0 ? IRAM_out[79:62] : 
					SW[2:0] == 3'd1 ? IRAM_out[61:44] :
					SW[2:0] == 3'd2 ? IRAM_out[43:26] :
					SW[2:0] == 3'd3 ? IRAM_out[25:8] : 
					SW[2:0] == 3'd4 ? {10'd0,IRAM_out[7:0]} : currentPacket[25:8];

sdram_pll neg_3ns (CLOCK_50, DRAM_CLK);


wire baudClock, baudClock_8Times, baudClock_fast8;
wire[7:0] lastSerialReceived;
wire [7:0] dataCounter;
wire [8:0] receive_error_check;
wire dataReady;
wire errorFlag;
wire packet_timeout;  // signal that the current packet has timedout
wire [79:0] packet1; //the current packet data
wire packet1_ready; //signal that the current packet is ready
wire packet1_crc_result; //the CRC result of the current packet
wire transmit_idle;
wire [79:0] last_packet; //the last packet received
wire [7:0] crc;
wire [7:0] lastCRC; //the last CRC result received
wire sendInProgress; //is the module currently sending

//The baud generator
BaudGenerator bg1(	.clock_in(CLOCK_50),
					.baud_clock_out(baudClock)
				  );
//8 times baud generator
BaudGenerator_8Times bg8t1(	.clock_in(CLOCK_50),
							.baud_clock_out(baudClock_8Times)
							);
//better 8 times as fast baud generator							
BaudGenerator_fast bgf1(.clock_in(CLOCK_50),
						.baud_clock_out(baudClock_fast8)
						);
//the serial receiver
SerialReceiver_improved_fastClock sr_i1(
			.CLOCK_50(CLOCK_50),
			.UART_RXD(UART_RXD),
			.lastReceived(lastSerialReceived),
			.dataReady_out(dataReady),
			.errorFlag_out(errorFlag),
			.reset(~KEY[0]),
			.error_check(receive_error_check),
			.timeout(packet_timeout),
			.baud_clock(baudClock),
			.baud_8_clock(baudClock_fast8)
			);



//The Packet manager module
wire [79:0] currentPacket;
wire currentPacketCRC;
wire currentPacket_isAvailable;
wire [7:0] packetID;
PacketManager_updated pmu1(
							.data_clock(dataReady),
							.data_in(lastSerialReceived),
							.latestPacket(currentPacket),
							.packetCRC(currentPacketCRC),
							.packetIsAvailable(currentPacket_isAvailable),
							.reset(~KEY[0]),
							.grab_clock(grabPacketClock),
							.fast_clock(VGA_CTRL_CLK),
							.PR(LEDG[1]),
							.packetID(packetID)
							);
wire pavail;	
wire [79:0] pdata;					
/*PacketHolder ph1(
					.packet_in_avail(currentPacket_isAvailable), 
					
					.packet_out_avail(pavail), 
					
					.packet_request_in(grabPacketClock)//~KEY[2])
					);*/
					
TransmitClock tc2(
					.tSend_clk_in(currentPacket_isAvailable),//~KEY[3]),
					.tSend_signal_out(pavail),
					.tSend_reset_in(~KEY[0] | grabPacketClock)
				);

wire currentlySendingData;
SerialTransmitter_updated STU1( 
								.CLOCK_50(CLOCK_50),
								.UART_TXD(UART_TXD),
								.toTransmit({2'b0,currentPacket[79:74]}),//{8{currentPacketCRC}}),//SW[7:0]),//
								.reset(~KEY[0]),
								.sendNew(transclk),//sendDataClock),
								.baud_clock(baudClock),
								.sendInProgress(gotSend)//currentlySendingData)
								);
												
wire transclk;
wire gotSend;
//assign LEDR[11] = gotSend;
TransmitClock tc1(
					.tSend_clk_in(sendDataClock | ~KEY[3]),//~KEY[3]),
					.tSend_signal_out(transclk),
					.tSend_reset_in(~KEY[0] | gotSend)
					);

//assign LEDR[8:6] = drawMode;
//assign LEDR[5:0] = instr_req;
//assign LEDR[10:9] = {readFrame,writeFrame};
//assign LEDR[15:8] = packetID[7:0];
assign LEDG[0] = pavail;
//assign LEDG[1] = currentPacketCRC;
assign LEDG[2] = currentPacketCRC;


endmodule //top module








