// --------------------------------------------------------------------
// Copyright (c) 2005 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
// Major Functions:	VGA DLA simulator
// modifed by BRL4 for SRAM; Displays a color grid 
// 320/240, 12 bit color
// VGA controller, PLL, and reset are from DE2 distribution CD
// --------------------------------------------------------------------

module DE2_Default_old_for_reference
	(
		////////////////////	Clock Input	 	////////////////////	 
		CLOCK_27,						//	27 MHz
		CLOCK_50,						//	50 MHz
		EXT_CLOCK,						//	External Clock
		////////////////////	Push Button		////////////////////
		KEY,							//	Pushbutton[3:0]
		////////////////////	DPDT Switch		////////////////////
		SW,								//	Toggle Switch[17:0]
		////////////////////	7-SEG Dispaly	////////////////////
		HEX0,							//	Seven Segment Digit 0
		HEX1,							//	Seven Segment Digit 1
		HEX2,							//	Seven Segment Digit 2
		HEX3,							//	Seven Segment Digit 3
		HEX4,							//	Seven Segment Digit 4
		HEX5,							//	Seven Segment Digit 5
		HEX6,							//	Seven Segment Digit 6
		HEX7,							//	Seven Segment Digit 7
		////////////////////////	LED		////////////////////////
		LEDG,							//	LED Green[8:0]
		LEDR,							//	LED Red[17:0]
		////////////////////////	UART	////////////////////////
		UART_TXD,						//	UART Transmitter
		UART_RXD,						//	UART Receiver
		////////////////////////	IRDA	////////////////////////
		IRDA_TXD,						//	IRDA Transmitter
		IRDA_RXD,						//	IRDA Receiver
		/////////////////////	SDRAM Interface		////////////////
		DRAM_DQ,						//	SDRAM Data bus 16 Bits
		DRAM_ADDR,						//	SDRAM Address bus 12 Bits
		DRAM_LDQM,						//	SDRAM Low-byte Data Mask 
		DRAM_UDQM,						//	SDRAM High-byte Data Mask
		DRAM_WE_N,						//	SDRAM Write Enable
		DRAM_CAS_N,						//	SDRAM Column Address Strobe
		DRAM_RAS_N,						//	SDRAM Row Address Strobe
		DRAM_CS_N,						//	SDRAM Chip Select
		DRAM_BA_0,						//	SDRAM Bank Address 0
		DRAM_BA_1,						//	SDRAM Bank Address 0
		DRAM_CLK,						//	SDRAM Clock
		DRAM_CKE,						//	SDRAM Clock Enable
		////////////////////	Flash Interface		////////////////
		FL_DQ,							//	FLASH Data bus 8 Bits
		FL_ADDR,						//	FLASH Address bus 22 Bits
		FL_WE_N,						//	FLASH Write Enable
		FL_RST_N,						//	FLASH Reset
		FL_OE_N,						//	FLASH Output Enable
		FL_CE_N,						//	FLASH Chip Enable
		////////////////////	SRAM Interface		////////////////
		SRAM_DQ,						//	SRAM Data bus 16 Bits
		SRAM_ADDR,						//	SRAM Address bus 18 Bits
		SRAM_UB_N,						//	SRAM High-byte Data Mask 
		SRAM_LB_N,						//	SRAM Low-byte Data Mask 
		SRAM_WE_N,						//	SRAM Write Enable
		SRAM_CE_N,						//	SRAM Chip Enable
		SRAM_OE_N,						//	SRAM Output Enable
		////////////////////	ISP1362 Interface	////////////////
		OTG_DATA,						//	ISP1362 Data bus 16 Bits
		OTG_ADDR,						//	ISP1362 Address 2 Bits
		OTG_CS_N,						//	ISP1362 Chip Select
		OTG_RD_N,						//	ISP1362 Write
		OTG_WR_N,						//	ISP1362 Read
		OTG_RST_N,						//	ISP1362 Reset
		OTG_FSPEED,						//	USB Full Speed,	0 = Enable, Z = Disable
		OTG_LSPEED,						//	USB Low Speed, 	0 = Enable, Z = Disable
		OTG_INT0,						//	ISP1362 Interrupt 0
		OTG_INT1,						//	ISP1362 Interrupt 1
		OTG_DREQ0,						//	ISP1362 DMA Request 0
		OTG_DREQ1,						//	ISP1362 DMA Request 1
		OTG_DACK0_N,					//	ISP1362 DMA Acknowledge 0
		OTG_DACK1_N,					//	ISP1362 DMA Acknowledge 1
		////////////////////	LCD Module 16X2		////////////////
		LCD_ON,							//	LCD Power ON/OFF
		LCD_BLON,						//	LCD Back Light ON/OFF
		LCD_RW,							//	LCD Read/Write Select, 0 = Write, 1 = Read
		LCD_EN,							//	LCD Enable
		LCD_RS,							//	LCD Command/Data Select, 0 = Command, 1 = Data
		LCD_DATA,						//	LCD Data bus 8 bits
		////////////////////	SD_Card Interface	////////////////
		SD_DAT,							//	SD Card Data
		SD_DAT3,						//	SD Card Data 3
		SD_CMD,							//	SD Card Command Signal
		SD_CLK,							//	SD Card Clock
		////////////////////	USB JTAG link	////////////////////
		TDI,  							// CPLD -> FPGA (data in)
		TCK,  							// CPLD -> FPGA (clk)
		TCS,  							// CPLD -> FPGA (CS)
	    TDO,  							// FPGA -> CPLD (data out)
		////////////////////	I2C		////////////////////////////
		I2C_SDAT,						//	I2C Data
		I2C_SCLK,						//	I2C Clock
		////////////////////	PS2		////////////////////////////
		PS2_DAT,						//	PS2 Data
		PS2_CLK,						//	PS2 Clock
		////////////////////	VGA		////////////////////////////
		VGA_CLK,   						//	VGA Clock
		VGA_HS,							//	VGA H_SYNC
		VGA_VS,							//	VGA V_SYNC
		VGA_BLANK,						//	VGA BLANK
		VGA_SYNC,						//	VGA SYNC
		VGA_R,   						//	VGA Red[9:0]
		VGA_G,	 						//	VGA Green[9:0]
		VGA_B,  						//	VGA Blue[9:0]
		////////////	Ethernet Interface	////////////////////////
		ENET_DATA,						//	DM9000A DATA bus 16Bits
		ENET_CMD,						//	DM9000A Command/Data Select, 0 = Command, 1 = Data
		ENET_CS_N,						//	DM9000A Chip Select
		ENET_WR_N,						//	DM9000A Write
		ENET_RD_N,						//	DM9000A Read
		ENET_RST_N,						//	DM9000A Reset
		ENET_INT,						//	DM9000A Interrupt
		ENET_CLK,						//	DM9000A Clock 25 MHz
		////////////////	Audio CODEC		////////////////////////
		AUD_ADCLRCK,					//	Audio CODEC ADC LR Clock
		AUD_ADCDAT,						//	Audio CODEC ADC Data
		AUD_DACLRCK,					//	Audio CODEC DAC LR Clock
		AUD_DACDAT,						//	Audio CODEC DAC Data
		AUD_BCLK,						//	Audio CODEC Bit-Stream Clock
		AUD_XCK,						//	Audio CODEC Chip Clock
		////////////////	TV Decoder		////////////////////////
		TD_DATA,    					//	TV Decoder Data bus 8 bits
		TD_HS,							//	TV Decoder H_SYNC
		TD_VS,							//	TV Decoder V_SYNC
		TD_RESET,						//	TV Decoder Reset
		////////////////////	GPIO	////////////////////////////
		GPIO_0,							//	GPIO Connection 0
		GPIO_1							//	GPIO Connection 1
	);

////////////////////////	Clock Input	 	////////////////////////
input			CLOCK_27;				//	27 MHz
input			CLOCK_50;				//	50 MHz
input			EXT_CLOCK;				//	External Clock
////////////////////////	Push Button		////////////////////////
input	[3:0]	KEY;					//	Pushbutton[3:0]
////////////////////////	DPDT Switch		////////////////////////
input	[17:0]	SW;						//	Toggle Switch[17:0]
////////////////////////	7-SEG Dispaly	////////////////////////
output	[6:0]	HEX0;					//	Seven Segment Digit 0
output	[6:0]	HEX1;					//	Seven Segment Digit 1
output	[6:0]	HEX2;					//	Seven Segment Digit 2
output	[6:0]	HEX3;					//	Seven Segment Digit 3
output	[6:0]	HEX4;					//	Seven Segment Digit 4
output	[6:0]	HEX5;					//	Seven Segment Digit 5
output	[6:0]	HEX6;					//	Seven Segment Digit 6
output	[6:0]	HEX7;					//	Seven Segment Digit 7
////////////////////////////	LED		////////////////////////////
output	[8:0]	LEDG;					//	LED Green[8:0]
output	[17:0]	LEDR;					//	LED Red[17:0]
////////////////////////////	UART	////////////////////////////
output			UART_TXD;				//	UART Transmitter
input			UART_RXD;				//	UART Receiver
////////////////////////////	IRDA	////////////////////////////
output			IRDA_TXD;				//	IRDA Transmitter
input			IRDA_RXD;				//	IRDA Receiver
///////////////////////		SDRAM Interface	////////////////////////
inout	[15:0]	DRAM_DQ;				//	SDRAM Data bus 16 Bits
output	[11:0]	DRAM_ADDR;				//	SDRAM Address bus 12 Bits
output			DRAM_LDQM;				//	SDRAM Low-byte Data Mask 
output			DRAM_UDQM;				//	SDRAM High-byte Data Mask
output			DRAM_WE_N;				//	SDRAM Write Enable
output			DRAM_CAS_N;				//	SDRAM Column Address Strobe
output			DRAM_RAS_N;				//	SDRAM Row Address Strobe
output			DRAM_CS_N;				//	SDRAM Chip Select
output			DRAM_BA_0;				//	SDRAM Bank Address 0
output			DRAM_BA_1;				//	SDRAM Bank Address 0
output			DRAM_CLK;				//	SDRAM Clock
output			DRAM_CKE;				//	SDRAM Clock Enable
////////////////////////	Flash Interface	////////////////////////
inout	[7:0]	FL_DQ;					//	FLASH Data bus 8 Bits
output	[21:0]	FL_ADDR;				//	FLASH Address bus 22 Bits
output			FL_WE_N;				//	FLASH Write Enable
output			FL_RST_N;				//	FLASH Reset
output			FL_OE_N;				//	FLASH Output Enable
output			FL_CE_N;				//	FLASH Chip Enable
////////////////////////	SRAM Interface	////////////////////////
inout	[15:0]	SRAM_DQ;				//	SRAM Data bus 16 Bits
output	[17:0]	SRAM_ADDR;				//	SRAM Address bus 18 Bits
output			SRAM_UB_N;				//	SRAM High-byte Data Mask
output			SRAM_LB_N;				//	SRAM Low-byte Data Mask 
output			SRAM_WE_N;				//	SRAM Write Enable
output			SRAM_CE_N;				//	SRAM Chip Enable
output			SRAM_OE_N;				//	SRAM Output Enable
////////////////////	ISP1362 Interface	////////////////////////
inout	[15:0]	OTG_DATA;				//	ISP1362 Data bus 16 Bits
output	[1:0]	OTG_ADDR;				//	ISP1362 Address 2 Bits
output			OTG_CS_N;				//	ISP1362 Chip Select
output			OTG_RD_N;				//	ISP1362 Write
output			OTG_WR_N;				//	ISP1362 Read
output			OTG_RST_N;				//	ISP1362 Reset
output			OTG_FSPEED;				//	USB Full Speed,	0 = Enable, Z = Disable
output			OTG_LSPEED;				//	USB Low Speed, 	0 = Enable, Z = Disable
input			OTG_INT0;				//	ISP1362 Interrupt 0
input			OTG_INT1;				//	ISP1362 Interrupt 1
input			OTG_DREQ0;				//	ISP1362 DMA Request 0
input			OTG_DREQ1;				//	ISP1362 DMA Request 1
output			OTG_DACK0_N;			//	ISP1362 DMA Acknowledge 0
output			OTG_DACK1_N;			//	ISP1362 DMA Acknowledge 1
////////////////////	LCD Module 16X2	////////////////////////////
inout	[7:0]	LCD_DATA;				//	LCD Data bus 8 bits
output			LCD_ON;					//	LCD Power ON/OFF
output			LCD_BLON;				//	LCD Back Light ON/OFF
output			LCD_RW;					//	LCD Read/Write Select, 0 = Write, 1 = Read
output			LCD_EN;					//	LCD Enable
output			LCD_RS;					//	LCD Command/Data Select, 0 = Command, 1 = Data
////////////////////	SD Card Interface	////////////////////////
inout			SD_DAT;					//	SD Card Data
inout			SD_DAT3;				//	SD Card Data 3
inout			SD_CMD;					//	SD Card Command Signal
output			SD_CLK;					//	SD Card Clock
////////////////////////	I2C		////////////////////////////////
inout			I2C_SDAT;				//	I2C Data
output			I2C_SCLK;				//	I2C Clock
////////////////////////	PS2		////////////////////////////////
input		 	PS2_DAT;				//	PS2 Data
input			PS2_CLK;				//	PS2 Clock
////////////////////	USB JTAG link	////////////////////////////
input  			TDI;					// CPLD -> FPGA (data in)
input  			TCK;					// CPLD -> FPGA (clk)
input  			TCS;					// CPLD -> FPGA (CS)
output 			TDO;					// FPGA -> CPLD (data out)
////////////////////////	VGA			////////////////////////////
output			VGA_CLK;   				//	VGA Clock
output			VGA_HS;					//	VGA H_SYNC
output			VGA_VS;					//	VGA V_SYNC
output			VGA_BLANK;				//	VGA BLANK
output			VGA_SYNC;				//	VGA SYNC
output	[9:0]	VGA_R;   				//	VGA Red[9:0]
output	[9:0]	VGA_G;	 				//	VGA Green[9:0]
output	[9:0]	VGA_B;   				//	VGA Blue[9:0]
////////////////	Ethernet Interface	////////////////////////////
inout	[15:0]	ENET_DATA;				//	DM9000A DATA bus 16Bits
output			ENET_CMD;				//	DM9000A Command/Data Select, 0 = Command, 1 = Data
output			ENET_CS_N;				//	DM9000A Chip Select
output			ENET_WR_N;				//	DM9000A Write
output			ENET_RD_N;				//	DM9000A Read
output			ENET_RST_N;				//	DM9000A Reset
input			ENET_INT;				//	DM9000A Interrupt
output			ENET_CLK;				//	DM9000A Clock 25 MHz
////////////////////	Audio CODEC		////////////////////////////
output/*inout*/	AUD_ADCLRCK;			//	Audio CODEC ADC LR Clock
input			AUD_ADCDAT;				//	Audio CODEC ADC Data
inout			AUD_DACLRCK;			//	Audio CODEC DAC LR Clock
output			AUD_DACDAT;				//	Audio CODEC DAC Data
inout			AUD_BCLK;				//	Audio CODEC Bit-Stream Clock
output			AUD_XCK;				//	Audio CODEC Chip Clock
////////////////////	TV Devoder		////////////////////////////
input	[7:0]	TD_DATA;    			//	TV Decoder Data bus 8 bits
input			TD_HS;					//	TV Decoder H_SYNC
input			TD_VS;					//	TV Decoder V_SYNC
output			TD_RESET;				//	TV Decoder Reset
////////////////////////	GPIO	////////////////////////////////
inout	[35:0]	GPIO_0;					//	GPIO Connection 0
inout	[35:0]	GPIO_1;					//	GPIO Connection 1

//////////////////////////////////////////////////////////////////////
////////////////////////////////////
//DLA state machine variables
wire reset;
reg [17:0] addr_reg; //memory address register for SRAM
reg [15:0] data_reg; //memory data register  for SRAM
reg we ;		//write enable for SRAM
//reg [3:0] state;	//state machine
//reg [7:0] led;		//debug led register
//reg [30:0] x_rand;	//shift registers for random number gen  
//reg [28:0] y_rand;
//wire seed_low_bit, x_low_bit, y_low_bit; //rand low bits for SR
//reg [8:0] x_walker; //particle coords
//reg [8:0] y_walker;
//reg [3:0] sum; //neighbor sum
reg lock; //did we stay in sync?
//reg memwait; //slow mem?
////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

//	LCD ON
assign	LCD_ON		=	1'b0;
assign	LCD_BLON	=	1'b0;

//	All inout port turn to tri-state
assign	DRAM_DQ		=	16'hzzzz;
assign	FL_DQ		=	8'hzz;
assign	SRAM_DQ		=	16'hzzzz;
assign	OTG_DATA	=	16'hzzzz;
assign	SD_DAT		=	1'bz;
assign	ENET_DATA	=	16'hzzzz;
assign	GPIO_0		=	36'hzzzzzzzzz;
assign	GPIO_1		=	36'hzzzzzzzzz;

wire [31:0]	mSEG7_DIG;
reg	 [31:0]	Cont;
wire		VGA_CTRL_CLK;
wire		AUD_CTRL_CLK;
wire [9:0]	mVGA_R;
wire [9:0]	mVGA_G;
wire [9:0]	mVGA_B;
wire [19:0]	mVGA_ADDR;			//video memory address
wire [9:0]  Coord_X, Coord_Y;	//display coods
wire		DLY_RST;

assign	TD_RESET	=	1'b1;	//	Allow 27 MHz input
//assign	AUD_ADCLRCK	=	AUD_DACLRCK;
//assign	AUD_XCK		=	AUD_CTRL_CLK;

Reset_Delay			r0	(	.iCLK(CLOCK_50),.oRESET(DLY_RST)	);

VGA_Audio_PLL 		p1	(	.areset(~DLY_RST),.inclk0(CLOCK_27),.c0(VGA_CTRL_CLK),.c1(AUD_CTRL_CLK),.c2(VGA_CLK)	);


VGA_Controller		vga1	(	//	Host Side
							.iCursor_RGB_EN(4'b0111),
							.oAddress(mVGA_ADDR),
							.oCoord_X(Coord_X),
							.oCoord_Y(Coord_Y),
							.iRed(mVGA_R),
							.iGreen(mVGA_G),
							.iBlue(mVGA_B),
							//	VGA Side
							.oVGA_R(VGA_R),
							.oVGA_G(VGA_G),
							.oVGA_B(VGA_B),
							.oVGA_H_SYNC(VGA_HS),
							.oVGA_V_SYNC(VGA_VS),
							.oVGA_SYNC(VGA_SYNC),
							.oVGA_BLANK(VGA_BLANK),
							//	Control Signal
							.iCLK(VGA_CTRL_CLK),
							.iRST_N(DLY_RST)	);


// SRAM_control
assign SRAM_ADDR = addr_reg;
assign SRAM_DQ = (we)? 16'hzzzz : data_reg ;
assign SRAM_UB_N = 0;					// hi byte select enabled
assign SRAM_LB_N = 0;					// lo byte select enabled
assign SRAM_CE_N = 0;					// chip is enabled
assign SRAM_WE_N = we;					// write when ZERO
assign SRAM_OE_N = 0;					//output enable is overidden by WE

// Show SRAM on the VGA
assign  mVGA_R = {SRAM_DQ[15:12], 6'b0} ;
assign  mVGA_G = {SRAM_DQ[11:8], 6'b0} ;
assign  mVGA_B = {SRAM_DQ[7:4], 6'b0} ;

// DLA state machine
assign reset = ~KEY[0];
//assign LEDG = state;

//right-most bit for rand number shift regs
//your basic XOR random # gen
assign x_low_bit = x_rand[27] ^ x_rand[30];
assign y_low_bit = y_rand[26] ^ y_rand[28];

//state names
parameter init=4'd0, test1=4'd1, test2=4'd2, test3=4'd3, test4=4'd4, test5=4'd5, test6=4'd6, 
	draw_walker=4'd7, update_walker=4'd8, new_walker=4'd9 ;





`define AREA 100
`define LENGTH 10
`define LENGTH_m1 9
`define HALF_LENGTH 5
`define SIZE 26:0
`define SELECT_SIZE 9:0

parameter rho=27'h4000;

parameter draw=0, halt=1;

//wire signed [`SIZE] u011, u021, u101, u111, u121, u131, u201, u211, u221, u231, u311, u321;
//wire signed [`SIZE] u01, u02, u10, u11, u12, u13, u20, u21, u22, u23, u31, u32;
wire signed boundaryGain;

wire signed [`SIZE] u[`AREA];
wire signed [`SIZE] u1[`AREA];
wire signed [`SIZE] u2_outs[`AREA];
//wire signed [`SIZE] u1_outs[`AREA];
//wire signed [`SIZE] lefties[`AREA];
//wire signed [`SIZE] righties[`AREA];
//wire signed [`SIZE] topies[`AREA];
//wire signed [`SIZE] bottomies[`AREA];
//wire [`SELECT_SIZE] left_indices[`AREA];
//wire [`SELECT_SIZE] right_indices[`AREA];
//wire [`SELECT_SIZE] top_indices[`AREA];
//wire [`SELECT_SIZE] bottom_indices[`AREA];

wire signed [`SIZE] mult_result;

wire [`SIZE] curr_left, curr_right, curr_top, curr_bottom, curr_me, curr_me_prev;
/*
assign curr_left 	= lefties	[select_bits][`SIZE];
assign curr_right 	= righties	[select_bits][`SIZE];
assign curr_top 	= topies	[select_bits][`SIZE];
assign curr_bottom 	= bottomies	[select_bits][`SIZE];
assign curr_me 		= u1_outs	[select_bits][`SIZE];
assign curr_me_prev = u2_outs	[select_bits][`SIZE];
*/
/*
assign curr_left 	= u1		[left_indices[select_bits][`SELECT_SIZE]][`SIZE];
assign curr_top 	= u1		[top_indices[select_bits][`SELECT_SIZE]][`SIZE];
assign curr_bottom 	= u1		[bottom_indices[select_bits][`SELECT_SIZE]][`SIZE];
assign curr_me 		= u1		[select_bits][`SIZE];
assign curr_me_prev = u2_outs	[select_bits][`SIZE];
*/

assign curr_left 		= u1[select_bits - 10'd1		][`SIZE];
assign curr_right 		= u1[select_bits + 10'd1		][`SIZE];
assign curr_top 		= u1[select_bits - 10'd`LENGTH	][`SIZE];
assign curr_bottom 		= u1[select_bits + 10'd`LENGTH	][`SIZE];
assign curr_me 			= u1[select_bits				][`SIZE];
assign curr_me_prev 	= u2_outs[select_bits][`SIZE];

// rho/(1+eta)
wire signed [`SIZE] rdoe;
// 2/(1+eta)
wire signed [`SIZE] tdoe;
// (1 - eta)/(1+eta)
wire signed [`SIZE] ome;

//assume rho = .05
//assume eta = .0002
assign rdoe = 27'hCCC2; //.05 = rho / (1+eta)
assign tdoe = 27'h1FFE5C; //1.9996 = 2 / (1+eta)
assign ome = 27'hFFE5C; //.9996 = (1-eta) / (1+eta)

// [rho / (1+eta)] * (sum(sides) - 4*self)
wire signed [`SIZE] rhomult;
signed_mult27 pilsbury_rho_boy(rhomult,rdoe,(curr_left + curr_right + curr_top + curr_bottom - curr_me - curr_me - curr_me - curr_me));

// [2 / (1+eta)] * self
wire signed [`SIZE] eta1mult;
signed_mult27 eta1(eta1mult, tdoe, curr_me);

// [(1 - eta) / (1 + eta)] * previous_self
wire signed [`SIZE] eta2mult;
signed_mult27 eta2(eta2mult, ome, curr_me_prev);

assign mult_result = rhomult + eta1mult - eta2mult;

//wire signed [`SIZE] test_mult;
//signed_mult27 tt(test_mult, 27'h180000, 27'h180000);

//assign LEDR = oneHZclk;
//assign LEDR= SW[7] ? u1[SW[6:0]][26:9] : u2_outs[SW[6:0]][26:9];
/*assign LEDR = SW[17:16] == 2'd0 ? left_indices[SW[9:0]][`SELECT_SIZE] :
				SW[17:16] == 2'd1 ? right_indices[SW[9:0]][`SELECT_SIZE]:
				SW[17:16] == 2'd2 ? top_indices[SW[9:0]][`SELECT_SIZE]: bottom_indices[SW[9:0]][`SELECT_SIZE];
*/

//shift right by 1
//assign boundaryGain = 18'h4;

//wire [17:0] mult_result;
//assign LEDR[17:10] = mult_result[17:10];
//signed_mult sm1(mult_result, {SW[17:9],9'd0},{SW[8:0],9'd0});

//big_ass_multiplexer(

reg [`SELECT_SIZE] select_bits;
//assign LEDG = select_bits;
reg [6:0] iireg, jjreg;
/*
reg oneHZclk;
reg [24:0] clk_div_counter;

always @ (posedge CLOCK_50)
begin
	if(clk_div_counter < 25'hFFFFFF)
	begin
		clk_div_counter <= clk_div_counter + 25'd1;
		oneHZclk <= 1'd0;
	end
	else if(clk_div_counter == 25'h1FFFFFF) begin
		clk_div_counter <= 25'd0;
	end
	else begin
		clk_div_counter <= clk_div_counter + 25'd1;
		oneHZclk <= 1'd1;
	end
end
*/

//used to change the select bits
always @ (posedge VGA_CTRL_CLK)
begin
	if(reset) begin
		select_bits <= 10'd0;
		iireg <= 7'd0;
		jjreg <= 7'd0;
		addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;	// [17:0]
		we <= 1'b0;								//write some memory
		data_reg <= 16'b0;						//write all zeros (black)	
	end
	else if ((~VGA_VS | ~VGA_HS) & KEY[3]) begin
		if(select_bits < 10'd`AREA) begin
			select_bits <= select_bits + 10'd1;
			we <= 1'b0;
			addr_reg <= {offset + {2'b0,iireg},offset+{2'b0,jjreg}};
			
			data_reg <= u[select_bits][26] ? {4'b0, u1[select_bits][22:19], 8'b0} : {u1[select_bits][22:19], 12'b0};//{u01[9:6],12'b0};
			if(iireg == 7'd`LENGTH_m1) begin
				iireg <= 7'd0;
				if(jjreg == 7'd`LENGTH_m1) begin
					jjreg <= 7'd0;
				end
				else begin
					jjreg <= 7'd1 + jjreg;
				end
			end
			else begin
				iireg <= 7'd1 + iireg;
			end
		end
		else begin
			select_bits <= 10'd0;
			iireg <= 7'd0;
			jjreg <= 7'd0;
		end
	end
	else
	begin
		lock <= 1'b0; //clear lock if display starts because this destroys mem addr_reg
		addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;
		we <= 1'b1;
	end
end

genvar i;
genvar j;
generate
	for(j = 1; j<`LENGTH_m1; j = j + 1) begin : PES_J
		for(i = 1; i < `LENGTH_m1; i = i + 1) begin : PES_I
		
		PE4 P(
				.u(u[j*`LENGTH + i][`SIZE]), 
				.uinit(27'h0), 
				.u1(u1[j*`LENGTH + i][`SIZE]), 
				.reset(~KEY[0]), 
				.clk(VGA_CTRL_CLK),
				.me_prev_out(u2_outs[j*`LENGTH + i][`SIZE]), 
				.mult_result_in(mult_result),
				.my_select_bits(j*`LENGTH + i), 
				.wanted_select_bits(select_bits), 
				.clk_test(~KEY[1]), 
				.i(i), 
				.j(j)
			);
		
		/*
			PE3 P(	.left_index(j*`LENGTH + i - 1),
					.right_index(j*`LENGTH +i + 1),
					.top_index((j-1)*`LENGTH + i), 
					.bottom_index((j+1)*`LENGTH + i), 
					.u(u[j*`LENGTH + i][`SIZE]), 
					.uinit(27'h100000), 
					.u1(u1[j*`LENGTH + i][`SIZE]), 
					.reset(~KEY[0]), 
					.clk(VGA_CTRL_CLK),
					.left_index_out(left_indices[j*`LENGTH + i][`SELECT_SIZE]), 
					.right_index_out(right_indices[j*`LENGTH + i][`SELECT_SIZE]), 
					.top_index_out(top_indices[j*`LENGTH + i][`SELECT_SIZE]), 
					.bottom_index_out(bottom_indices[j*`LENGTH + i][`SELECT_SIZE]), 
					.me_prev_out(u2_outs[j*`LENGTH + i][`SIZE]), 
					.mult_result_in(mult_result),
					.my_select_bits(j*`LENGTH + i), 
					.wanted_select_bits(select_bits), 
					.clk_test(~KEY[1]), 
					.i(i), 
					.j(j));
			*/
			/*if(((i >= 6)&&(i <=7)) && ((j <= 6)&&(j >= 7))) begin
			
				PE2 P(.eta(1), .rho(rho), 
							  .left1(u1[j*`LENGTH + i - 1][`SIZE] ),
							  .right1(u1[j*`LENGTH + i + 1][`SIZE]),
							  .top1(u1[(j-1)*`LENGTH + i][`SIZE] ),
							  .bottom1(u1[(j+1)*`LENGTH + i][`SIZE] ),
							  .u(u[j*`LENGTH + i][`SIZE]),
							  .uinit(27'h100000),
							  .i(i),
							  .j(j),
							  .u1(u1[j*`LENGTH + i][`SIZE]),
							  .reset(~KEY[0]),
							  .clk(VGA_CTRL_CLK),
							  .left1_out(lefties[j*`LENGTH + i][`SIZE]),
							  .right1_out(righties[j*`LENGTH + i][`SIZE]),
							  .top1_out(topies[j*`LENGTH + i][`SIZE]),
							  .bottom1_out(bottomies[j*`LENGTH + i][`SIZE]),
							  .me_out(u1_outs[j*`LENGTH + i][`SIZE]), //the u1 to the multiplier
							  .mult_result_in(mult_result),  //the result from the multiplier
							  .my_select_bits(j*`LENGTH + i), //the select bits for this module
							  .wanted_select_bits(select_bits), //the select bits from the state machine
							  .clk_test(~KEY[1]),
							  //.u2(u2_outs[j*10+i][`SIZE]),
							  .me_prev_out(u2_outs[j*`LENGTH + i][`SIZE])
							  ); //t
			end
			else begin
				PE2 P(.eta(1), .rho(rho), 
							  .left1(u1[j*`LENGTH + i - 1][`SIZE] ),
							  .right1(u1[j*`LENGTH + i + 1][`SIZE] ),
							  .top1(u1[(j-1)*`LENGTH + i][`SIZE] ),
							  .bottom1(u1[(j+1)*`LENGTH + i][`SIZE] ),
							  .u(u[j*`LENGTH + i][`SIZE]),
							  .uinit(27'h0000000),
							  .i(i),
							  .j(j),
							  .u1(u1[j*`LENGTH + i][`SIZE]),
							  .reset(~KEY[0]),
							  .clk(VGA_CTRL_CLK),
							  .left1_out(lefties[j*`LENGTH + i][`SIZE]),
							  .right1_out(righties[j*`LENGTH + i][`SIZE]),
							  .top1_out(topies[j*`LENGTH + i][`SIZE]),
							  .bottom1_out(bottomies[j*`LENGTH + i][`SIZE]),
							  .me_out(u1_outs[j*`LENGTH + i][`SIZE]), //the u1 to the multiplier
							  .mult_result_in(mult_result),  //the result from the multiplier
							  .my_select_bits(j*`LENGTH + i), //the select bits for this module
							  .wanted_select_bits(select_bits), //the select bits from the state machine
							  .clk_test(~KEY[1]),
							  .me_prev_out(u2_outs[j*`LENGTH + i][`SIZE])); //the u2 to the multiplier
			end
			*/			  
		end
	end
endgenerate

/*
// grid
PE PE11(1, rho, u101, u121, u011, u211, u11, 0, u111, ~KEY[0], ~KEY[1]);
PE PE12(1, rho, u111, u131, u021, u221, u12, 0, u121, ~KEY[0], ~KEY[1]);
PE PE21(1, rho, u201, u221, u111, u311, u21, 0, u211, ~KEY[0], ~KEY[1]);
PE PE22(1, rho, u211, u231, u121, u321, u22, 27'h1000000, u221, ~KEY[0], ~KEY[1]);
//top
//might be problem to get u11 (u11 not set yet)
PEboundary B01(boundaryGain, u11, u01, u011, 0, ~KEY[0], ~KEY[1]);
PEboundary B02(boundaryGain, u12, u02, u021, 0, ~KEY[0], ~KEY[1]);
//bottom
PEboundary B31(boundaryGain, u21, u31, u311, 0, ~KEY[0], ~KEY[1]);
PEboundary B32(boundaryGain, u22, u32, u321, 0, ~KEY[0], ~KEY[1]);
//left
PEboundary B10(boundaryGain, u11, u10, u101, 0, ~KEY[0], ~KEY[1]);
PEboundary B20(boundaryGain, u21, u20, u201, 0, ~KEY[0], ~KEY[1]);
//right
PEboundary B13(boundaryGain, u12, u13, u131, 0, ~KEY[0], ~KEY[1]);
PEboundary B23(boundaryGain, u22, u23, u231, 0, ~KEY[0], ~KEY[1]);
*/

wire [8:0] offset;
assign offset = 150;


endmodule //top module
