module FrameUpdater(
					clock,
					sync,
					reset,
					available,
					my_id,
					req_id,
					Coord_X,
					Coord_Y,
					addr_reg,
					we,
					data_reg,
					frame_clk_out,
					command
					
);

input wire clock, sync, reset;
output reg available;
input wire [3:0] my_id, req_id;
input wire command;

input wire [9:0] Coord_X, Coord_Y;
output reg [17:0] addr_reg;
output reg we;
output reg [15:0] data_reg;

output reg frame_clk_out;


reg state;
parameter clockLow = 1'b0,
			clockHigh = 1'b1;
			
always @ (posedge clock) begin
	if(reset) begin
		state <= clockLow;
		we <= 1'b0;
		data_reg <= 0;
		addr_reg <= {Coord_X[9:1],Coord_Y[9:1]};
	end
	else begin
		if(sync) begin
			we <= 1'b1;
			case(state)
				clockLow: begin
					frame_clk_out <= 1'b0;
					if(command & (my_id == req_id)) begin
						available <= 1'b0;
						state <= clockHigh;
					end
					else begin
						available <= 1'b1;
					end
				end
				clockHigh: begin
					frame_clk_out <= 1'b1;
					state <= clockLow;
				end
				default: begin
					state <= clockLow;
					frame_clk_out <= 1'b0;
				end
			endcase
		end
		else
		begin
			addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;
			we <= 1'b1;
		end
	end
end


endmodule

