module NewPacketAvail(packet1_ready, took_packet, packet_avail, reset);

input wire packet1_ready, took_packet;
input wire reset;

reg packet_avail_reg;
output wire packet_avail;
assign packet_avail = packet_avail_reg;

reg [1:0] state;
parameter 	new_packet = 2'b01,
hold_it = 2'd2,
			what_packet = 2'b00;


always @ (packet1_ready, took_packet, reset)
begin
	if(reset) begin
		state <= what_packet;
		packet_avail_reg <= 1'b0;
	end
	else begin
		case(state)
			what_packet: begin
				if(packet1_ready) begin
					state <= new_packet;
					packet_avail_reg <= 1'b1;
				end
			end
			
			new_packet: begin
				if(took_packet) begin
					packet_avail_reg <= 1'b0;
					state <= what_packet;
				end
			end
			
			hold_it: begin
				
			end
		endcase
	end
end




endmodule
