//Peter Greczner, ALU

module ALU(control, A, B, C, isZero, isNegative, isEqual, isGT, isLT);

input wire [3:0] control;
input wire signed [31:0] A,B;
output reg [31:0] C;

output wire isZero, isNegative, isEqual, isGT, isLT;
assign isNegative = 0;

assign isZero = (C == 0) ? 1: 0;
assign isEqual = (A == B) ? 1 : 0;

assign isGT = (A > B) ? 1 : 0;
assign isLT = (A < B) ? 1 : 0;


parameter   add = 4'd0,
            subtract = 4'd1,
            shiftLeft = 4'd2,
            shiftRight = 4'd3,
            AND = 4'd4,
            OR = 4'd5,
            XOR = 4'd6,
            NAND = 4'd7,
            NOT = 4'd8,
            NOR = 4'd9,
            NOP = 4'd10;


always @ (control, A, B)
begin
    case(control)
        add: begin
            C = A + B;
        end
        
        subtract: begin
            C = A - B;
        end
        
        shiftLeft: begin
            C = A << B;
        end
        
        shiftRight: begin
            C = A >> B;
        end
        
        AND: begin
            C = A & B;
        end
        
        OR: begin
            C = A | B;
        end
        
        XOR: begin
            C = A ^ B;
        end
        
        NAND: begin
             C = ~(A & B);
        end
        
        NOT: begin
            C = ~A;
        end
        
        NOR: begin
            C = ~(A | B);
        end
        NOP: begin
            C = 0;
        end
        default: begin
            C = A | B;
        end
    endcase

end



endmodule

