//Peter Greczner, Branch Select

module BranchSelect(isBranch, isJump, ctrl_BS, alu_EQ, alu_Z, alu_GT, alu_LT, takeBranch);

input wire isBranch, isJump, alu_EQ, alu_Z, alu_GT, alu_LT;
input wire [3:0] ctrl_BS;

output wire takeBranch;

assign takeBranch =     ~(isBranch | isJump)    ? 0                     :
                        (ctrl_BS == BS_bgt)     ? (alu_GT)              :
                        (ctrl_BS == BS_blt)     ? (alu_LT)              :
                        (ctrl_BS == BS_bge)     ? (alu_GT | alu_EQ)     :
                        (ctrl_BS == BS_ble)     ? (alu_LT | alu_EQ)     :
                        (ctrl_BS == BS_beq)     ? (alu_EQ)              :
                        (ctrl_BS == BS_bne)     ? (~alu_EQ)             :
                        (ctrl_BS == BS_bnez)    ? (~alu_Z)              :
                        (ctrl_BS == BS_j)       ? 1                     :
                        (ctrl_BS == BS_jr)      ? 1                     :
                        (ctrl_BS == BS_jal)     ? 1                     : 0;
                        



parameter   BS_bgt = 4'd0,
            BS_blt = 4'd1,
            BS_bge = 4'd2,
            BS_ble = 4'd3,
            //BS_ble = 4'd4,
            BS_beq = 4'd5,
            BS_bne = 4'd6,
            BS_bez = 4'd7,
            BS_bnez = 4'd8,
            BS_j = 4'd9,
            BS_jr = 4'd10,
            BS_jal = 4'd11;


endmodule
