//Module Availability MUX

module availableMUX(select, availability_out, 
							LD_available, 
							CD_available, CF_available, 
							SD_available, SF_available,
							TW_available, 
							FU_available,
							clk,
							enable);
							
input wire [3:0] select;	
input wire enable;

output wire availability_out;
reg availablity_out_reg;
assign availability_out = availablity_out_reg;

input wire LD_available, CD_available, CF_available, SD_available, SF_available, TW_available, FU_available;
input wire clk;						
							
parameter 	[3:0] 	circle_fill = 4'd0,
					circle_draw = 4'd1,
					square_fill = 4'd2,
					square_draw = 4'd3,
					line_draw = 4'd4,
					text_write = 4'd5,
					frame_update = 4'd6,
					idle = 4'd15;
							
always @ (posedge clk) begin
	if(enable) begin
		case(select)
			circle_fill: begin
				availablity_out_reg <= CF_available;
			end
			circle_draw: begin
				availablity_out_reg <= CD_available;
			end
			square_fill: begin
				availablity_out_reg <= SF_available;
			end
			square_draw: begin
				availablity_out_reg <= SD_available;
			end
			line_draw: begin
				availablity_out_reg <= LD_available;
			end
			text_write: begin
				availablity_out_reg <= TW_available;
			end
			frame_update: begin
				availablity_out_reg <= FU_available;
			end
			idle: begin
				availablity_out_reg <= 1'b0;
			end
			default: begin
				availablity_out_reg <= 1'b0;
			end
		endcase
	end
end


endmodule

