module circle_draw(x1,y1,radius, VGA_SYNC, VGA_CLK, 
									data_reg, reset, color, command,
									available,
									my_id,
									id_req,
									xAddr, yAddr,
									write_clk,
									is_write_finished
									);
									
input wire signed [10:0] x1,y1;
input wire signed [10:0] radius;
input wire VGA_SYNC;
input wire VGA_CLK;
input wire [3:0] my_id, id_req;
//input wire [9:0] Coord_X, Coord_Y;
//output reg we; // we for SRAM
//output reg [17:0] addr_reg; //memory address register for SRAM
output reg [15:0] data_reg; //memory data register  for SRAM
//input wire draw;
input wire reset;
input wire [15:0] color;
input wire [1:0] command;
output wire available;
reg available_reg;
assign available = available_reg;

output reg write_clk;
input wire is_write_finished;

output reg [9:0] xAddr;
output reg [8:0] yAddr;

reg signed  [10:0] x;
reg signed  [10:0] y;
reg signed  [10:0] p;
reg signed [10:0] draw_x, draw_y;

reg [4:0] draw_state, next_state;
parameter start = 5'd0,
			loop = 5'd1,
			finish = 5'd2,
			calc = 5'd3,
			q1 = 5'd4,
			q2 = 5'd5,
			q3 = 5'd6,
			q4 = 5'd7,
			q5 = 5'd8,
			q6 = 5'd9,
			q7 = 5'd10,
			q8 = 5'd11,
			write_state = 5'd12;

always @ (posedge VGA_CLK) begin
	if(reset) begin
		draw_state <= finish;
		//clear the screen
		//addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;	// [17:0]
		//we <= 1'b0;								//write some memory
		data_reg <= 16'b0;						//write all zeros (black)
		available_reg <= 1'b0;
		write_clk <= 1'b0;
	end
	else if (VGA_SYNC) begin
		case (draw_state)
		
			write_state: begin
				if(is_write_finished) begin
					draw_state <= next_state;
					write_clk <= 1'b0;
				end
			end
		
			calc: begin
				//we <= 1'b1;
				if(x < y) begin
					//put the pixels
					//we <= 1'b0;
					draw_x <= x1 + x;
					draw_y <= y1 + y;
					draw_state <= q1;
					
					//draw_state <= finish;
				end
				else begin
					draw_state <= finish;
					//we <= 1'b1;
				end
				
			end
			
			q1: begin
				//we <= 1'b0;
				draw_x <= x1 - x;
				draw_y <= y1 + y;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q2;
				draw_state <= write_state;
				write_clk <= 1'b1;
				
				data_reg <= color;
				//draw_state <= q2;
			end
			
			q2: begin
				//we <= 1'b0;
				draw_x <= x1 + x;
				draw_y <= y1 - y;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q3;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q3;
			end
			
			q3: begin
				//we <= 1'b0;
				draw_x <= x1 - x;
				draw_y <= y1 - y;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q4;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q4;
			end
			
			q4: begin
				//we <= 1'b0;
				draw_x <= x1 + y;
				draw_y <= y1 + x;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q5;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q5;
			end
			
			q5: begin
				//we <= 1'b0;
				draw_x <= x1 - y;
				draw_y <= y1 + x;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q6;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q6;
			end
			
			q6: begin
				//we <= 1'b0;
				draw_x <= x1 + y;
				draw_y <= y1 - x;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q7;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q7;
			end
			
			q7: begin
				//we <= 1'b0;
				draw_x <= x1 - y;
				draw_y <= y1 - x;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= q8;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				//draw_state <= q8;
			end
			
			q8: begin
				//we <= 1'b0;
				//we <= 1'b0;
				//addr_reg <= {draw_x[8:0],draw_y[8:0]};
				//xAddr <= {1'b0,draw_x[8:0]};
				xAddr <= draw_x[9:0];
				yAddr <= draw_y[8:0];
				next_state <= calc;
				draw_state <= write_state;
				write_clk <= 1'b1;
				data_reg <= color;
				if (p < 0) begin
					p <= p + x + x + x + x + 11'd6;
					x <= x + 11'd1;
				end
				else begin
					p <= p + x + x + x + x - y - y - y - y + 11'd10;
					x <= x + 11'd1;
					y <= y - 11'd1;
				end
				//draw_state <= calc;
			end
			/*
			loop: begin
			
					we <= 1'b0;
					
					addr_reg <= {9'd200,9'd200};
					data_reg <= 16'h0F0F;
					
					draw_state <= finish;
			end*/
			
			finish: begin
				if(command[1] && (my_id == id_req)) begin
					draw_state <= calc;
					x <= 11'b0;
					y <= radius;
					p <= 11'd3 - radius - radius;
					available_reg <= 1'b0;
				end
				else begin
					available_reg <= 1'b1;
				end
				//we <= 1'b1;
			end
			
			default: begin
				//we <= 1'b1;
				draw_state <= finish;
			end
		endcase
	end
	else
	begin
		//addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;
		//we <= 1'b1;
	end
end



endmodule
