module circle_fill(x1,y1,radius, VGA_SYNC, VGA_CLK, 
									draw, reset, color, command,
									x1start_wire, y1start_wire,
									x2start_wire, y2start_wire, issue_line, line_clear);
									
input wire signed [10:0] x1,y1;
input wire signed [10:0] radius;
input wire VGA_SYNC;
input wire VGA_CLK;

output wire signed [10:0] x1start_wire, y1start_wire, x2start_wire, y2start_wire;
reg signed [10:0] x1start, y1start, x2start, y2start;
output reg issue_line;
input wire line_clear;

assign x1start_wire = x1start;
assign y1start_wire = y1start;
assign y2start_wire = y2start;
assign x2start_wire = x2start;




input wire draw;
input wire reset;
input wire [15:0] color;
input wire [1:0] command;


reg signed  [10:0] x;
reg signed  [10:0] y;
reg signed  [10:0] p;
reg signed [10:0] draw_x, draw_y;

reg [4:0] draw_state;
parameter start = 5'd0,
			loop = 5'd1,
			finish = 5'd2,
			calc = 5'd3,
			q1 = 5'd4,
			q2 = 5'd5,
			q3 = 5'd6,
			q4 = 5'd7,
			q5 = 5'd8,
			q6 = 5'd9,
			q7 = 5'd10,
			q8 = 5'd11,
			wait12done = 5'd12,
			wait34done = 5'd13,
			wait56done = 5'd14,
			wait78done = 5'd15,
			set12 = 5'd16,
			set34 = 5'd17,
			set56 = 5'd18,
			set78 = 5'd19;

always @ (posedge VGA_CLK) begin
	if(reset) begin
		draw_state <= finish;
		issue_line <= 1'b0;
	end
	else if (VGA_SYNC) begin
		case (draw_state)
			calc: begin
				issue_line <= 1'b0;
				if(x < y) begin
					draw_state <= set12;
					
				end
				else begin
					draw_state <= finish;
				end
				
			end
			
			set12: begin
				x1start <= x1 + x;
				y1start <= y1 + y;
				x2start <= x1 - x;
				y2start <= y1 + y;
				draw_state <= wait12done;
			end
			
			wait12done: begin
				if(line_clear && issue_line == 1'b0) begin
					issue_line <= 1'b1;
					
				end
				if(line_clear && issue_line == 1'b1) begin
					draw_state <= set56;
					issue_line <= 1'b0;
				end
				
			end
			
			set34: begin
				x1start <= x1 + x;
				y1start <= y1 - y;
				x2start <= x1-x;
				y2start <= y1-y;
				draw_state <= wait34done;
				
			end
			
			wait34done: begin
				if(line_clear && issue_line == 1'b0) begin
					issue_line <= 1'b1;
					
				end
				if(line_clear && issue_line == 1'b1) begin
					draw_state <= set56;
					issue_line <= 1'b0;
				end
			end
			
			set56: begin
				x1start <= x1+y;
				y1start <= y1+x;
				x2start <= x1-y;
				y2start <= y1+x;
				draw_state <= wait56done;
			end
			
			wait56done: begin
				if(line_clear && issue_line == 1'b0) begin
					issue_line <= 1'b1;
					
				end
				if(line_clear && issue_line == 1'b1) begin
					draw_state <= set78;
					issue_line <= 1'b0;
				end
			end
			
			set78: begin
				x1start <= x1+y;
				y1start <= y1-x;
				x2start <= x1-y;
				y2start <= y1-x;
				draw_state <= wait78done;
			end
			
			wait78done: begin
				if(line_clear && issue_line == 1'b0) begin
					issue_line <= 1'b1;
					
				end
				if(line_clear && issue_line == 1'b1) begin
					draw_state <= q8;
					issue_line <= 1'b0;
				end
				
			end
			
			q8: begin
				if (p < 0) begin
					p <= p + x + x + x + x + 11'd6;
					x <= x + 11'd1;
				end
				else begin
					p <= p + x + x + x + x - y - y - y - y + 11'd10;
					x <= x + 11'd1;
					y <= y - 11'd1;
				end
				draw_state <= calc;
			end
			
					
			finish: begin
				if(command[1]) begin
					draw_state <= calc;
					x <= 11'b0;
					y <= radius;
					p <= 11'd3 - radius - radius;
				end
				
			end
			
			default: begin
				draw_state <= finish;
			end
		endcase
	end
	
end

endmodule

