module circle_fill_better(x1,y1,radius, VGA_SYNC, VGA_CLK, 
									reset, color, command,
									data_reg, 
									available,
									my_id,
									id_req,
									xAddr, yAddr,
									write_clk,
									is_write_finished
									);
									
input wire signed [10:0] x1,y1;
input wire signed [10:0] radius;
input wire VGA_SYNC;
input wire VGA_CLK;

output reg write_clk;
input wire is_write_finished;

input wire [3:0] my_id, id_req;

output reg [9:0] xAddr;
output reg [8:0] yAddr;

//output wire signed [10:0] x1start_wire, y1start_wire, x2start_wire, y2start_wire;
reg signed [10:0] x1start, y1start, x2start, y2start;
//output reg issue_line;
//input wire line_clear;

//output reg we; // we for SRAM
//output reg [17:0] addr_reg; //memory address register for SRAM
output reg [15:0] data_reg; //memory data register  for SRAM
//input wire [9:0] Coord_X, Coord_Y;

//assign x1start_wire = x1start;
//assign y1start_wire = y1start;
//assign y2start_wire = y2start;
//assign x2start_wire = x2start;

output wire available;
reg available_reg;
assign available = available_reg;




//input wire draw;
input wire reset;
input wire [15:0] color;
input wire [1:0] command;


reg signed  [10:0] x;
reg signed  [10:0] y;
reg signed  [10:0] p;
reg signed [10:0] draw_x, draw_y;

reg [4:0] draw_state;
reg [4:0] next_state;
parameter start = 5'd0,
			loop = 5'd1,
			finish = 5'd2,
			calc = 5'd3,
			q1 = 5'd4,
			q2 = 5'd5,
			q3 = 5'd6,
			q4 = 5'd7,
			q5 = 5'd8,
			q6 = 5'd9,
			q7 = 5'd10,
			q8 = 5'd11,
			wait12done = 5'd12,
			wait34done = 5'd13,
			wait56done = 5'd14,
			wait78done = 5'd15,
			set12 = 5'd16,
			set34 = 5'd17,
			set56 = 5'd18,
			set78 = 5'd19,
			write_state = 5'd20;

always @ (posedge VGA_CLK) begin
	if(reset) begin
		draw_state <= finish;
		//issue_line <= 1'b0;
		
		//clear the screen
		//addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;	// [17:0]
		//we <= 1'b0;								//write some memory
		data_reg <= 16'b0;						//write all zeros (black)
		available_reg <= 1'b0;
		write_clk <= 1'b0;
	end
	else if (VGA_SYNC) begin
		case (draw_state)
		
			write_state: begin
				if(is_write_finished) begin
					draw_state <= next_state;
					write_clk <= 1'b0;
				end
			end
		
			calc: begin
				//issue_line <= 1'b0;
				if(x <= y) begin
					draw_state <= set12;
					
				end
				else begin
					draw_state <= finish;
				end
				
			end
			
			set12: begin
				//we <= 1'b1;
				x1start <= x1 + x;
				y1start <= y1 + y;
				x2start <= x1 - x;
				y2start <= y1 + y;
				draw_state <= wait12done;
			end
			
			wait12done: begin
				//we <= 1'b0;
				if(x2start < x1start) begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <= write_state;
					next_state <= wait12done;
					data_reg <= color;
					x2start <= x2start + 11'd1;
				end
				else begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= set34;
					data_reg <= color;
					//draw_state <= set34;
				end
				
			end
			
			set34: begin
				//we <= 1'b1;
				x1start <= x1 + x;
				y1start <= y1 - y;
				x2start <= x1-x;
				y2start <= y1-y;
				draw_state <= wait34done;
				
			end
			
			wait34done: begin
				//we <= 1'b0;
				if(x2start < x1start) begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= wait34done;
					data_reg <= color;
					x2start <= x2start + 11'd1;
				end
				else begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= set56;
					data_reg <= color;
					//draw_state <= set56;
				end
			end
			
			set56: begin
				//we <= 1'b1;
				x1start <= x1+y;
				y1start <= y1+x;
				x2start <= x1-y;
				y2start <= y1+x;
				draw_state <= wait56done;
			end
			
			wait56done: begin
				//we <= 1'b0;
				if(x2start < x1start) begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= wait56done;
					data_reg <= color;
					x2start <= x2start + 11'd1;
				end
				else begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= set78;
					data_reg <= color;
					//draw_state <= set78;
				end
			end
			
			set78: begin
				//we <= 1'b1;
				x1start <= x1+y;
				y1start <= y1-x;
				x2start <= x1-y;
				y2start <= y1-x;
				draw_state <= wait78done;
			end
			
			wait78done: begin
				//we <= 1'b0;
				if(x2start < x1start) begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <=  write_state;
					next_state <= wait78done;
					data_reg <= color;
					x2start <= x2start + 11'd1;
				end
				else begin
					//addr_reg <= {x2start[8:0], y1start[8:0]};
					//xAddr <= {1'b0,x2start[8:0]};
					xAddr <= x2start[9:0];
					yAddr <= y1start[8:0];
					write_clk <= 1'b1;
					draw_state <= write_state;
					next_state <= q8;
					data_reg <= color;
					//draw_state <= q8;
				end
				
			end
			
			q8: begin
				//we <= 1'b1;
				if (p < 0) begin
					p <= p + x + x + x + x + 11'd6;
					x <= x + 11'd1;
				end
				else begin
					p <= p + x + x + x + x - y - y - y - y + 11'd10;
					x <= x + 11'd1;
					y <= y - 11'd1;
				end
				draw_state <= calc;
			end
			
					
			finish: begin
				if(command[1] && (my_id == id_req)) begin
					draw_state <= calc;
					x <= 11'b0;
					y <= radius;
					p <= 11'd3 - radius - radius;
					available_reg <= 1'b0;
				end
				else begin
					available_reg <= 1'b1;
				end
				//we <= 1'b1;
				
			end
			
			default: begin
				draw_state <= finish;
				//we <= 1'b1;
			end
		endcase
	end
	else
	begin
		//addr_reg <= {Coord_X[9:1],Coord_Y[9:1]} ;
		//we <= 1'b1;
	end
	
end

endmodule

